//
// Created by tunahan on 13.12.20.
//
#include <iostream>
#include "../../external/leaf/all.hpp"

boost::leaf::result<std::shared_ptr<int>> foo(){
    return boost::leaf::new_error(boost::leaf::e_errno{-2});
}


boost::leaf::result<int> bar2(){
    return boost::leaf::new_error(boost::leaf::e_errno{-2});
}

boost::leaf::result<int> bar(){

    int leaf_eno = 0;
    std::cout << "foo?\n";
    auto leaf_err =  boost::leaf::try_handle_all(
            []() -> boost::leaf::result<std::shared_ptr<int>> {
                return boost::leaf::new_error(boost::leaf::e_errno{5543});

            },
            [] (boost::leaf::bad_result bad){
                std::cout << "bad result\n";
                std::cout << bad.load() << "\n";
                return nullptr;
            },
            [&](boost::leaf::e_errno eno){
                std::cout << "we get here with" << eno.value << " eno\n";
                leaf_eno = -1241;
                return nullptr;
            },
            [](boost::leaf::error_info const &unmatched){
                return nullptr;
            }
    );
    if(leaf_err){
        std::cout << "no nullptr\n";
    }else {
        std::cout << "LEAF_ENO " << leaf_eno << "\n";
    }
    return leaf_eno;
}

template <typename T>
inline int errno_from_error(boost::leaf::result<T> a){

    auto x = boost::leaf::try_catch(
            [&]() -> int {
                std::cout << "errno_from_error\n";
                return bar().value();
            },
            [](boost::leaf::e_errno a){
                std::cout << "errno\n";
                return a.value;
            }
    );
    std::cout << x << "\n";
    return x;
}

int main(){
    std::cout << errno_from_error(foo());
}